Include "xors3d.bb"


Global pe_aberration_enabled% = 1

;xCreateLog(LOG_HTML, LOG_INFO, "PostEffect_00.html")
xAppTitle("Chromatic Aberration post-effect")



xGraphics3D(1024, 768, 32, 0, 1)

; enable antialiasing
xAntiAlias  True


xMoveMouse xGraphicsWidth() / 2, xGraphicsHeight() / 2
Global mousespeed#       = 0.5
Global camerasmoothness# = 4.5
Global camxa# = 0
Global camya# = 0

Global camera = xCreateCamera()
xCameraClsColor(camera, 32, 64, 128)
xPositionEntity camera  ,0,20,-150

Global  light = xCreateLight()
xPositionEntity light ,25,150,-50



scene=xLoadMesh ("scene.b3d")

Global aberration = xLoadPostEffect("chromatic_aberration.fx")
xSetPostEffect(1, aberration)



While Not xKeyHit(KEY_ESCAPE)

	;rendering the world
	xRenderWorld
	;setting the backbuffer as a render target
	xSetBuffer xBackBuffer()

	
	PostEffectControl()
	CameraControl()

	xRenderWorld()

	
	Draw2D()
	xRenderPostEffects()
	PrintInfo()
	
	xFlip()
Wend

End



Function CameraControl()
	If xKeyDown(KEY_W) Then xMoveEntity camera,  0,  0,  1.0
	If xKeyDown(KEY_S) Then xMoveEntity camera,  0,  0, -1.0
	If xKeyDown(KEY_A) Then xMoveEntity camera, -1.0,  0,  0
	If xKeyDown(KEY_D) Then xMoveEntity camera,  1.0,  0,  0
	mxs# = CurveValue(xMouseXSpeed() * mousespeed, mxs, camerasmoothness)
	mys# = CurveValue(xMouseYSpeed() * mousespeed, mys, camerasmoothness)
	camxa# = camxa - mxs Mod 360
	camya# = camya + mys
	If camya < -89 Then camya = -89
	If camya >  89 Then camya =  89
	xMoveMouse(xGraphicsWidth() / 2, xGraphicsHeight() / 2)
	xRotateEntity(camera, camya, camxa, 0.0)
End Function

Function PostEffectControl()

	If xKeyHit(KEY_1)
		pe_aberration_enabled= 1 - pe_aberration_enabled
		If pe_aberration_enabled=True 
			xSetPostEffect(1, aberration)
		Else
			xSetPostEffect(1, 0)
		EndIf
	EndIf
End Function

Function PrintInfo()
	Local state$
	xColor(255, 128, 64, 128)
	xRect(9, 9, 312, 32, 0)
	xColor(0, 0, 0, 128)
	xRect(10, 10, 310, 30, 1)
	xColor(255, 255, 255, 255)

	If (pe_aberration_enabled = 1)
		state = "DISABLE"
	Else
		state = "ENABLE"
	EndIf
	xText(15, 15, "Press '1' to " + state + " Chromatic Aberration posteffect.")
End Function

Function Draw2D()
	xColor(255, 128, 0, 255)
	xRect(20, xGraphicsHeight() - 40, xGraphicsWidth() - 40, 30, 1)
	xColor(128, 55, 255, 255)
	xText(xGraphicsWidth() / 2, xGraphicsHeight() - 25, "We can post process 2d graphics too", 1, 1)
End Function

Function CurveValue#(newvalue#, oldvalue#, increments)
	If increments >  1 Then oldvalue# = oldvalue# - (oldvalue# - newvalue#) / increments 
	If increments <= 1 Then oldvalue# = newvalue# 
	Return oldvalue# 
End Function