
const texture sceneTexture : CURRENTBUFFER;



// Texture sampler to get access to texture pixels for shader
    sampler sceneSample = sampler_state
{
	// Assing texture to sampler
	Texture   = <sceneTexture>;
	// We always needs clamping for textures
	AddressU  = Clamp;
	AddressV  = Clamp;
	// Linear texture filtering, also you may use "Point" or "None"
	MinFilter = Linear;
	MagFilter = Linear;
	MipFilter = Linear;
};









 float4 PSEffect (float2 texCoords : TEXCOORD0) : COLOR0

{
          
	   float3 color = tex2D(sceneSample, texCoords);

          
        
          color.r=tex2D(sceneSample, (texCoords+.003)).r;
          color.g=tex2D(sceneSample, (texCoords+.001)).g;
          color.b=tex2D(sceneSample, (texCoords-.003)).b;


          return float4(color,1.0);
}
            
// Shaders techniques. Shader must contain at least one technique.
technique MainTechnique
{
	// Sequence of technique passes. This passes will performs on stage.
	pass Chromatic_Aberration
	{
		PixelShader	= compile ps_2_0 PSEffect();
	}
}